package com.example.mainapplicathiongeorge31p.navigation

import androidx.compose.runtime.Composable
import androidx.compose.ui.tooling.preview.Preview
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController
import com.example.mainapplicathiongeorge31p.screens.CodeInEmailSecondScreen
import com.example.mainapplicathiongeorge31p.screens.FirstScrenApp
import com.example.mainapplicathiongeorge31p.screens.StartScreen

@Composable
fun Navigation() {
    val navController = rememberNavController()
    NavHost(navController = navController,//контроллер реагирующий и отвечающий за перемещения
        startDestination = "FirstScreen")
    {
        //Для каждой страницы задается route - для дальнейшего обращения к ней
        //и указывается метод для запуска с переданными параметрами
        composable("FirstScreen") {
            FirstScrenApp(navController)
        }
        composable("StartScreen"){
            StartScreen(navController)
        }
        composable("CodeInEmail"){
            CodeInEmailSecondScreen(navController)
        }
    }
}
