package com.example.mainapplicathiongeorge31p.screens

import android.annotation.SuppressLint
import android.os.CountDownTimer
import androidx.compose.foundation.background
import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Row
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.size
import androidx.compose.foundation.layout.width
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.foundation.text.KeyboardActions
import androidx.compose.foundation.text.KeyboardOptions
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.KeyboardArrowLeft
import androidx.compose.material3.Button
import androidx.compose.material3.ButtonColors
import androidx.compose.material3.ButtonDefaults
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.material3.Icon
import androidx.compose.material3.IconButton
import androidx.compose.material3.IconButtonColors
import androidx.compose.material3.IconButtonDefaults
import androidx.compose.material3.MaterialTheme
import androidx.compose.material3.Text
import androidx.compose.material3.TextField
import androidx.compose.material3.TextFieldDefaults
import androidx.compose.runtime.Composable
import androidx.compose.runtime.LaunchedEffect
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.setValue
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.focus.FocusDirection
import androidx.compose.ui.focus.FocusRequester
import androidx.compose.ui.focus.focusRequester
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.platform.LocalFocusManager
import androidx.compose.ui.text.TextStyle
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.text.input.KeyboardType
import androidx.compose.ui.text.style.TextAlign
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.navigation.NavHostController
import kotlinx.coroutines.delay
import kotlin.time.Duration.Companion.seconds

@OptIn(ExperimentalMaterial3Api::class)
@SuppressLint("RememberReturnType")
//@Preview(showBackground = true)

@Composable

fun CodeInEmailSecondScreen(navController: NavHostController) {

    val focusManager = LocalFocusManager.current
    val (digit1, setDigit1) = remember {
        mutableStateOf("")
    }
    val (digit2, setDigit2) = remember {
        mutableStateOf("")
    }
    val (digit3, setDigit3) = remember {
        mutableStateOf("")
    }
    val (digit4, setDigit4) = remember {
        mutableStateOf("")
    }
    LaunchedEffect(
        key1 = digit1,
    ) {
        if (digit1.isNotEmpty()) {
            focusManager.moveFocus(
                focusDirection = FocusDirection.Next,
            )
        }
    }
    LaunchedEffect(
        key1 = digit2,
    ) {
        if (digit2.isNotEmpty()) {
            focusManager.moveFocus(
                focusDirection = FocusDirection.Next,
            )
        }
    }
    LaunchedEffect(
        key1 = digit3,
    ) {
        if (digit3.isNotEmpty()) {
            focusManager.moveFocus(
                focusDirection = FocusDirection.Next,
            )
        }
    }
    Box(modifier = Modifier.padding(top = 20.dp, start = 15.dp)) {
       Button(
           onClick = { navController.navigate("StartScreen") },
           shape = RoundedCornerShape(8.dp),
           modifier = Modifier
               .height(30.dp)
               .width(30.dp),
           colors = ButtonDefaults.buttonColors(
               containerColor = Color(0xFFF5F5F9)
           )
       ) {}
       Icon(
           Icons.Filled.KeyboardArrowLeft,
           contentDescription = null,
           tint = Color.Gray,
           modifier = Modifier.padding(start = 3.dp, top = 4.dp)
       )
   }
    Column (modifier = Modifier
        .background(Color(0xfffffff))
        .fillMaxSize(),
        verticalArrangement = Arrangement.Center) {
        Text(
            text = "Введите код из E-mail",
            fontSize = 15.sp,
            fontWeight = FontWeight.Bold,
            modifier = Modifier
                .fillMaxWidth(1f),
            textAlign = TextAlign.Center
        )
        Row(modifier = Modifier
            .padding(start=70.dp, end=70.dp, top = 25.dp), horizontalArrangement = Arrangement.SpaceAround) {
            TextField(
                value = digit1,
                onValueChange = { setDigit1(it) },
                modifier = Modifier
                    .padding(0.dp, 0.dp, 15.dp, 0.dp)
                    .weight(25f)
                    .height(50.dp),
                maxLines = 1,
                textStyle = TextStyle(
                    fontSize = 18.sp,
                    textAlign = TextAlign.Center),
                keyboardOptions = KeyboardOptions(keyboardType = KeyboardType.Number),
                shape = RoundedCornerShape(13.dp),
                colors = TextFieldDefaults.textFieldColors(
                    containerColor = Color(0xFFF5F5F9),
                    focusedIndicatorColor = Color.Transparent,
                    unfocusedIndicatorColor = Color.Transparent,
                    cursorColor = Color.Black,
                    unfocusedPlaceholderColor = Color.Gray,
                    disabledTextColor = Color.Transparent,
                    disabledIndicatorColor = Color.Transparent
                )
            )
            TextField(
                value = digit2,
                onValueChange = { setDigit2(it) },
                modifier = Modifier
                    .padding(0.dp, 0.dp, 15.dp, 0.dp)
                    .weight(25f)
                    .height(50.dp),
                maxLines = 1,
                textStyle = TextStyle(
                    fontSize = 18.sp,
                    textAlign = TextAlign.Center),
                keyboardOptions = KeyboardOptions(keyboardType = KeyboardType.Number),
                shape = RoundedCornerShape(13.dp),
                colors = TextFieldDefaults.textFieldColors(
                    containerColor = Color(0xFFF5F5F9),
                    focusedIndicatorColor = Color.Transparent,
                    unfocusedIndicatorColor = Color.Transparent,
                    cursorColor = Color.Black,
                    unfocusedPlaceholderColor = Color.Gray,
                    disabledTextColor = Color.Transparent,
                    disabledIndicatorColor = Color.Transparent
                )
            )
            TextField(
                value = digit3,
                onValueChange = { setDigit3(it) },
                modifier = Modifier
                    .padding(0.dp, 0.dp, 15.dp, 0.dp)
                    .weight(25f)
                    .height(50.dp),
                maxLines = 1,
                textStyle = TextStyle(
                    fontSize = 18.sp,
                    textAlign = TextAlign.Center),
                keyboardOptions = KeyboardOptions(keyboardType = KeyboardType.Number),
                shape = RoundedCornerShape(13.dp),
                colors = TextFieldDefaults.textFieldColors(
                    containerColor = Color(0xFFF5F5F9),
                    focusedIndicatorColor = Color.Transparent,
                    unfocusedIndicatorColor = Color.Transparent,
                    cursorColor = Color.Black,
                    unfocusedPlaceholderColor = Color.Gray,
                    disabledTextColor = Color.Transparent,
                    disabledIndicatorColor = Color.Transparent
                )
            )
            TextField(
                value = digit4,
                onValueChange = { setDigit4(it) },
                modifier = Modifier
                    .padding(0.dp, 0.dp, 15.dp, 0.dp)
                    .weight(25f)
                    .height(50.dp),
                maxLines = 1,
                textStyle = TextStyle(
                    fontSize = 18.sp,
                    textAlign = TextAlign.Center),
                keyboardOptions = KeyboardOptions(keyboardType = KeyboardType.Number),
                shape = RoundedCornerShape(13.dp),
                colors = TextFieldDefaults.textFieldColors(
                    containerColor = Color(0xFFF5F5F9),
                    focusedIndicatorColor = Color.Transparent,
                    unfocusedIndicatorColor = Color.Transparent,
                    cursorColor = Color.Black,
                    unfocusedPlaceholderColor = Color.Gray,
                    disabledTextColor = Color.Transparent,
                    disabledIndicatorColor = Color.Transparent
                )
            )
        }
        var ticks by remember { mutableStateOf(60) }
        LaunchedEffect(Unit) {
            while(true) {
                if(ticks >= 0){
                    delay(1.seconds)
                    ticks--
                }
                else break
            }
        }
        Text(
            text = "Отправить код повторно можно\r\nбудет через ${ticks} секунд",
            fontSize = 15.sp,
            modifier = Modifier
                .fillMaxWidth(1f)
                .padding(top = 10.dp),
            textAlign = TextAlign.Center,
            color = Color(0xFF939396),
            lineHeight = 20.sp)
    }
}




