package com.example.mainapplicathiongeorge31p.screens

import android.annotation.SuppressLint
import android.content.res.Configuration
import androidx.compose.foundation.Image
import androidx.compose.foundation.background
import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Row
import androidx.compose.foundation.layout.fillMaxHeight
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.size
import androidx.compose.foundation.layout.wrapContentSize
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.LaunchedEffect
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.graphics.Brush
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.graphics.ImageBitmap
import androidx.compose.ui.platform.LocalConfiguration
import androidx.compose.ui.res.imageResource
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.navigation.NavHostController
import com.example.mainapplicathiongeorge31p.R
import kotlinx.coroutines.delay

@OptIn(ExperimentalMaterial3Api::class)
@SuppressLint("RememberReturnType")

@Composable
fun FirstScrenApp(navController: NavHostController) {
    val configuration = LocalConfiguration.current
    if (configuration.orientation == Configuration.ORIENTATION_PORTRAIT) {
        // portrait mode
        LaunchedEffect(key1 = true) {
            // Customize the delay time
            delay(1500L)
            navController.navigate("StartScreen") {
                popUpTo("FirstScreen") //удаляет страницу и стека, чтобы не было возможности вернуться к этому экрану
                {
                    inclusive = true
                }
            }
        }
    Column(modifier = Modifier
        .fillMaxWidth()
        .fillMaxHeight()


        .fillMaxSize()
        .background(
            brush = Brush.linearGradient(
                colors = listOf(
                    Color(android.graphics.Color.parseColor("#70bce3")),
                    Color(android.graphics.Color.parseColor("#5c97e0")),
                    Color(android.graphics.Color.parseColor("#517de4")),

                    Color(android.graphics.Color.parseColor("#3f66ea")),
                    Color(android.graphics.Color.parseColor("#2856f2")),
                    Color(android.graphics.Color.parseColor("#2856f2")),
                    Color(android.graphics.Color.parseColor("#3f66ea")),
                    Color(android.graphics.Color.parseColor("#517de4")),
                    Color(android.graphics.Color.parseColor("#5c97e0")),
                    Color(android.graphics.Color.parseColor("#70bce3")),
                )
            )
        ),
        horizontalAlignment = Alignment.CenterHorizontally,
        verticalArrangement = Arrangement.Center)
     {
        Row {
            Text(
                text = "Смартлаб",
                fontSize = 30.sp,
                color = Color.White,
                fontWeight = FontWeight.Bold
            )
            Image(
                bitmap = ImageBitmap.imageResource(R.drawable.shape),
                contentDescription = "Иконка",
                modifier = Modifier
                    .size(45.dp, 40.dp)
                    .padding(start=10.dp)
            )
        }
     }
    }
}
